﻿EnableExplicit
; Long Constants
#LANG_NOR       =  0
#LANG_ENG       =  1
#LANG_END       =  1

#CheckValue     = 1337

#Languages      = 2
#Locations$                  = "rlllabchralanehd"
#Line$                       = "------------------------------------------------------"
#StatNames$                  = "STR CON SIZ INT POW DEX APP"
#ArmorStyles$                = "Distributed Penalty Armor Bleeds"
#Languages$                  = "Norwegian English"
XIncludeFile "FileErrorMessages.pb"
IncludeFile "Colornames.pbi"
;--- Display Window Module
XIncludeFile "KeyConstants.pbi"
XIncludeFile "AsciiDefinitions.pbi"
XIncludeFile "FileandFolderExist.pb"
XIncludeFile "Creature_Structures.pbi"
XIncludeFile "Structures.pbi"

Structure EquipmentTotal
	Weapons.l
	Clothings.l
	Runes.l
	EnchantmentGroups.l
EndStructure

Structure Sorcery
	Id.l
	flgRange.a
	flgType.a
	flgTime.a
EndStructure



;--- Variables for Equipment
;XIncludeFile "..\source-Shared\Weapon_Clothing_Enchanment_Struct.pbi"
Global.s Dim SorceryName(#LANG_END, 0)
Global.Sorcery Dim Sorcery(0)
Global.s Dim ColorDescription(5, 0)
Global.l Dim ColorCodes(0)
Global.i SingleWordCount
Global.s Dim Singlewords(#LANG_END, 0)
Global.s Dim gWeaponNAME(#LANG_END,0)
Global.s Dim gWeaponDesc(#LANG_END,0)
Global.s Dim gClothingName(#LANG_END,0)
Global.s Dim gClothingDesc(#LANG_END,0)
Global.ItemDataWeapon Dim gWeaponsData(0)
Global.EnchantmentGroup Dim gEnchantmentGroups(0)
Global.ItemDataClothing Dim gClothing(0)
Global.Rune Dim Runes(0)
Global.l Dim HairID(0)
Global.s Dim HairDescription(#LANG_END, 0)
Global.EquipmentTotal EquipmentTotal
;----------------------------------
Global.f Default_CompileVersion
Global.w Default_CompileIncrements
Global.f Default_TempCompileVersion
Global.w Default_TempCompileIncrements

#COMMANDIDENTIFIERHEADER$   = "GameData"
#VersionMayor               = 1
#VersionMinor               = 1
#Languages                  = 2
#RootSource$                = "Datafiles\"
#DestinationFolder$         = "DataFiles\"
;#RootSource$                = "F:\Projects\Programming\Purebasic\Dice100\Source-Tools\Datafiles\"
;#DestinationFolder$         = "F:\Projects\Programming\Purebasic\Dice100\Executable-Server\ProgramData\"
#DestinationFile$           = "Gamedata.bin"
#File1$                     = "Weaponcommands.csv"
#File2$                     = "Creatures.race"
#File3$                     = "CivilSkills.csv"
#NUMERIC0                   = 48
#NUMERIC9                   = 57
; Returns errors
#FileStructure            = 1000
#FileNotFound             = 1010
#AllocateMemoryError      = 1020
#DestLanguageFirst        = 0
#destlanguageNorwegian    = 0
#destlanguageEnglish      = 1
#DestLanguageLast         = 1
#WeaponSkillsCount        = 4
#CharWidth                = SizeOf(character)
#UnicodeLength            = 2

Structure ErrorReplay
	FileName.s
	ErrorNumber.l	
	FileToCloseNumber.i
	LineNumber.i
EndStructure

;--- Skipline
#ascInchSign                = 39 ; Char '
#ascLeftSlash               = 92 ; Char \
#ascUnderScore              = 95 ; Char _
#ascMostleft                = 62 ; Char >

Structure Skipline
    wSpace.w
    wLevel.w
    TextData.s
EndStructure

Structure Civil
	Language.s[#Languages]
	Flag.a
	id.l
	Groupid.w
	Base.u
EndStructure

;--- Creatures
#TotalAttributes = 7
#Max_CritAreas   = 6

#STAT_STRENGTH                       = 0
#STAT_CONSTITUTION                   = 1
#STAT_SIZE                           = 2
#STAT_INTELLIGENCE                   = 3
#STAT_POWER                          = 4
#STAT_DEXTERITY                      = 5
#STAT_APPEARANCE                     = 6

Global.Entities Dim Creature(0)
;--- WeaponSkills Structures
Structure WeaponSkillsEx
	ID.l
	BaseAttackSkill.u
	BaseParrySkill.u
	Language.s[#Languages]
EndStructure

Structure SeparateCommand
	Command.s
	Parameter.s
EndStructure

Structure Ls
	Text.s
	Language.u
EndStructure

Macro Stringsplit(string, ArrayUpperbound, ArgumentArray, StringToFind, intLoop)
	ArrayUpperbound = CountString(string, StringToFind)
    Dim ArgumentArray(ArrayUpperbound)
    For intLoop = 0 To ArrayUpperbound
    	ArgumentArray(intLoop) = StringField(string, intLoop + 1, StringToFind)
    Next intLoop
EndMacro
	DeclareModule DisplayWindows	
		EnableExplicit
		IncludeFile "Colornames.pbi"
		#GadgetWindowSizeChars = 1024 * 1024 * 1024
		Global.i WindowDisplayGeneralHandle
		Global.i RTFGagdetHandle
		Declare.i InformationWindow()
		Declare.i DisplayWindowActivity()
		Declare.i Editor_Text(Text.s)
		Declare.i Editor_Text2(Color.l, Text.s)
		Declare Editor_TextColor(Color.l)
	EndDeclareModule
	Module DisplayWindows
		Global.charFormat2 CharFormat
		
		Procedure Editor_TextColor(Color.l) 
			Protected.CharFormat2 Format
			  	format\cbSize = SizeOf(CHARFORMAT2) 
			  	format\dwMask = #CFM_COLOR 
			  	format\crTextColor = Color 
			  	SendMessage_(GadgetID(RTFGagdetHandle), #EM_SETCHARFORMAT, #SCF_SELECTION, @format) 
		EndProcedure

		Procedure.i Editor_Text(Text.s)
			Protected.i TxtLength
			Protected.i OriginalLength
		    ;--- Strings
		    If Not Len(Text)
		        ProcedureReturn #False
		    EndIf
		    ; # Get length of text from Editbox with the handle "VB6DebugWindowHandle"
		    OriginalLength = SendMessage_(GadgetID(RTFGagdetHandle), #WM_GETTEXTLENGTH , 0 ,0)
		    ; # If the editbox already have text, we add at CRLF to the beginning of the string.
		    ; # Length of thee new text
		    TxtLength = Len(Text)
		    ; # Place the INSERT position at the end of the text
		    SendMessage_(GadgetID(RTFGagdetHandle), #EM_SETSEL , OriginalLength, OriginalLength)
		    ; # Insert the text
		    SendMessage_(GadgetID(RTFGagdetHandle), #EM_REPLACESEL , 0, @Text)
		    OriginalLength + TxtLength
		    ; # Place the INSERT position at the end of the text
		    SendMessage_(GadgetID(RTFGagdetHandle), #EM_SETSEL , OriginalLength, OriginalLength)
		    ; # Place caret at the end of the text
		    SendMessage_(GadgetID(RTFGagdetHandle), #EM_SCROLLCARET, 0, 0)
		    ProcedureReturn #True
		EndProcedure
	
		Procedure.i Editor_Text2(Color.l, Text.s)
			Editor_TextColor(Color) : Editor_Text(text)
		EndProcedure

	
		Procedure.i InformationWindow()
			Protected.rect DesktopRect
			Protected.i ChoosenMonitor
			ChoosenMonitor = 0
			ExamineDesktops()
			Protected.l Width, height
			SystemParametersInfo_(#SPI_GETWORKAREA,0,@DesktopRect,0)
;			Debug Str(Desktoprect\left) + " - " + Str(DesktopRect\top) + " : " + Str(DesktopRect\right) + " - " + Str(DesktopRect\bottom)
			WindowDisplayGeneralHandle = OpenWindow(#PB_Any, 0, 0, 0, 0,"Work in Progress", #PB_Window_SystemMenu | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget | #PB_Window_Invisible)
			
			SetWindowPos_(WindowID(WindowDisplayGeneralHandle),#HWND_NOTOPMOST,DesktopX(ChoosenMonitor), DesktopY(ChoosenMonitor), DesktopRect\right, DesktopRect\bottom, #SWP_NOACTIVATE)
			Width = WindowWidth(WindowDisplayGeneralHandle, #PB_Window_InnerCoordinate)
			Height = WindowHeight(WindowDisplayGeneralHandle, #PB_Window_InnerCoordinate)
			;ResizeWindow(WindowDisplayGeneralHandle, DesktopX(ChoosenMonitor), DesktopY(ChoosenMonitor), DesktopRect\right, DesktopRect\bottom)
			RTFGagdetHandle = EditorGadget(#PB_Any, 10,10, Width - 20, Height - 20)
			SendMessage_(GadgetID(RTFGagdetHandle), #EM_LIMITTEXT, #GadgetWindowSizeChars , 0)
			SetWindowColor(WindowDisplayGeneralHandle, #CrDarkGreen)
			SetGadgetColor(RTFGagdetHandle, #PB_Gadget_BackColor, #crGreen)
			HideWindow(WindowDisplayGeneralHandle, #False)
		EndProcedure
		Procedure DisplayWindowActivity()
			Protected.i WindowEvent  ; Window activity
			Protected.i EventWindow  ; Window that had activity
			Repeat
				WindowEvent = WindowEvent()
				If WindowEvent
					EventWindow = EventWindow()
					Select EventWindow
					Case WindowDisplayGeneralHandle		
						If WindowEvent = #PB_Event_CloseWindow
							Break
						EndIf
					EndSelect
				Else
					Delay(10)
				EndIf
			ForEver
			CloseWindow(WindowDisplayGeneralHandle)
		EndProcedure
	EndModule
	;--- Parse Hair Description
	Procedure.i ParseHair(ifile.i, FileNameAndPath.s, *ErrorData.ErrorReplay)
		Protected.i FileIndex, ParsedCount
		Protected.u TextLength
		Protected.i LineCount, fLineCount, LanguageCount
		Protected.i NumberOfDescription
		Protected.i x
		Protected.s fText, Dim parsed(0)
		If Not win32::FileExist(FileNameAndPath)
			*ErrorData\ErrorNumber = #io_err_file_not_found
			ProcedureReturn #False
	    EndIf
	    FileIndex = ReadFile(#PB_Any, FileNameAndPath, #PB_File_NoBuffering | #PB_Ascii)
	    If FileIndex
		    Repeat
		    	If Eof(FileIndex)
		    		CloseFile(Fileindex)
	    			Break
		    	EndIf	
		    	fText = ReadString(FileIndex, #PB_Ascii)
	        	Stringsplit(ftext, ParsedCount, Parsed, #TAB$, x)
	        	If ParsedCount <> 2
	        		*ErrorData\ErrorNumber = #io_err_data_Structure_Error
	        		*ErrorData\LineNumber = fLineCount + 1
	        		CloseFile(FileIndex)
	        		ProcedureReturn #False
				EndIf
				;### Numbers of Color Description
				If Not fLineCount
					NumberOfDescription = Val(parsed(0))
					DisplayWindows::Editor_Text2(#crWhite, Str(NumberOfDescription) + " Hairs to parse." + #CRLF$)
					Dim HairID(NumberOfDescription - 1)
					Dim HairDescription(#LANG_END, NumberOfDescription - 1)
				EndIf
				If fLineCount > 3
					HairID(LineCount) = Val(parsed(0))
					For x = 0 To #LANG_END
						HairDescription(x, LineCount) = Parsed(x + 1)
					Next x
					LineCount + 1
				EndIf
				fLineCount + 1
			ForEver
			For x = 1 To NumberOfDescription
				WriteLong(ifile, HairID(x - 1))
			Next x
			For LanguageCount = 0 To #LANG_END
				Textlength = 0 
				For x = 1 To NumberOfDescription
					Textlength + StringByteLength(HairDescription(LanguageCount, x - 1)) + SizeOf(Unicode) 
				Next x
				WriteLong(ifile, TextLength)
				For x = 1 To NumberOfDescription
					TextLength = Len(HairDescription(LanguageCount, x - 1))
					WriteUnicodeCharacter(ifile, TextLength)
					WriteString(ifile, HairDescription(LanguageCount, x - 1), #PB_Unicode)
				Next x
			Next LanguageCount
		Else
			*ErrorData\ErrorNumber = #io_err_CouldNotOpenFile
			ProcedureReturn #False
		EndIf
		ProcedureReturn #True
	EndProcedure
	;--- Parse Sorcery
	Procedure.i ParseSorcery(ifile.i, FileNameAndPath.s, *ErrorData.ErrorReplay)
		Protected.i NumberOfSpells, ParsedCount
		Protected.i LineCount, fLineCount, LanguageCount
		Protected.i BlockSize
		Protected.u TextLength
		Protected.i FileIndex
		Protected.i x
		Protected.s fText, Dim Parsed(0)
		*ErrorData\FileName = FileNameAndPath
		*ErrorData\LineNumber = 0
		If Not win32::FileExist(FileNameAndPath)
			*ErrorData\ErrorNumber = #io_err_file_not_found
			ProcedureReturn #False
	    EndIf
	    FileIndex = ReadFile(#PB_Any, FileNameAndPath, #PB_File_NoBuffering | #PB_Ascii)
	    If FileIndex
		    Repeat
		    	If Eof(FileIndex)
		    		CloseFile(Fileindex)
	    			Break
		    	EndIf	
		    	fText = ReadString(FileIndex, #PB_Ascii)
	        	Stringsplit(ftext, ParsedCount, Parsed, #TAB$, x)
	        	If ParsedCount <> 5
	        		*ErrorData\ErrorNumber = #io_err_data_Structure_Error
	        		*ErrorData\LineNumber = fLineCount + 1
	        		CloseFile(FileIndex)
	        		ProcedureReturn #False
				EndIf
				;### Numbers of Sorcery Spells
				If Not fLineCount
					NumberOfSpells = Val(parsed(0))
					DisplayWindows::Editor_Text2(#crWhite, Str(NumberOfSpells) + " Sorcery Spells to parse." + #CRLF$)
					Dim sorcery(NumberOfSpells - 1)
					Dim SorceryName(#LANG_END, NumberOfSpells - 1)
				EndIf
				fLineCount + 1
				If fLineCount > 4
					sorcery(LineCount)\Id = Val(parsed(0))
					sorcery(LineCount)\flgRange = Val(parsed(1))
					sorcery(LineCount)\flgType = Val(parsed(2))
					sorcery(LineCount)\flgTime = Val(parsed(3))
					For x = 0 To #LANG_END
						SorceryName(x, LineCount) = Parsed(4 + x)
					Next x
					LineCount + 1
				EndIf
			ForEver
			;### Write out codes
			For x = 1 To NumberOfSpells
				WriteData(ifile, @Sorcery(x - 1), SizeOf(sorcery))
			Next x
			
			For LanguageCount = 0 To #LANG_END
				BlockSize = 0
				For x = 1 To NumberOfSpells
					BlockSize + StringByteLength(SorceryName(LanguageCount, x - 1), #PB_Unicode) + SizeOf(unicode) 
				Next x
				; Bytes to skip
				WriteLong(ifile, BlockSize)
				For x = 1 To NumberOfSpells
					TextLength = Len(SorceryName(LanguageCount, x - 1))
					WriteUnicodeCharacter(ifile, TextLength)
					WriteString(ifile, SorceryName(LanguageCount, x - 1))
				Next x
			Next LanguageCount
		Else	
			*ErrorData\ErrorNumber = #io_err_CouldNotOpenFile
			ProcedureReturn #False
		EndIf
		ProcedureReturn #True
	EndProcedure
	;--- Parse Color Description
	Procedure.i ParseColorDescriptions(ifile.i, FileNameAndPath.s, *ErrorData.ErrorReplay)
		Protected.i NumberOfColors, ParsedCount, LanguageCount
		Protected.i FileIndex
		Protected.i x, z, fLineCount, LineCount
		Protected.s Dim Parsed(0)
		Protected.s fText
		Protected.u a,b,c
		*ErrorData\FileName = FileNameAndPath
		*ErrorData\LineNumber = 0
		If Not win32::FileExist(FileNameAndPath)
			*ErrorData\ErrorNumber = #io_err_file_not_found
			ProcedureReturn #False
	    EndIf
	    FileIndex = ReadFile(#PB_Any, FileNameAndPath, #PB_File_NoBuffering | #PB_Ascii)
	    If FileIndex
		    Repeat
		    	If Eof(FileIndex)
		    		CloseFile(Fileindex)
	    			Break
		    	EndIf	
		    	fText = ReadString(FileIndex, #PB_Ascii)
	        	Stringsplit(ftext, ParsedCount, Parsed, #TAB$, z)
	        	If ParsedCount <> 6
	        		*ErrorData\ErrorNumber = #io_err_data_Structure_Error
	        		*ErrorData\LineNumber = fLineCount + 1
	        		CloseFile(FileIndex)
	        		ProcedureReturn #False
				EndIf
				;### Numbers of Color Description
				If Not fLineCount
					NumberOfColors = Val(parsed(0))
					DisplayWindows::Editor_Text2(#crWhite, Str(NumberOfColors) + " Colors to parse." + #CRLF$)
					Dim ColorCodes(NumberOfColors - 1)
					Dim ColorDescription(5, NumberOfColors - 1)
				EndIf
				fLineCount + 1
				If fLineCount > 3
					ColorCodes(LineCount) = Val(parsed(0))
					For x = 1 To 6
						ColorDescription(x - 1, LineCount) = Parsed(x)
					Next x
					LineCount + 1
				EndIf
			ForEver
			;### Write out codes
			For x = 1 To NumberOfColors
				Debug Str(ColorCodes(x - 1)) + " : " + Hex(ColorCodes(x - 1))
				WriteLong(ifile, ColorCodes(x - 1))
			Next x
			
			For LanguageCount = 0 To #LANG_END
				z = 0
				For x = 1 To NumberOfColors
					z + StringByteLength(ColorDescription((LanguageCount * 3), x - 1), #PB_Unicode) + SizeOf(unicode) 
					z + StringByteLength(ColorDescription((LanguageCount * 3) + 1, x - 1), #PB_Unicode) + SizeOf(unicode) 
					z + StringByteLength(ColorDescription((LanguageCount * 3) + 2, x - 1), #PB_Unicode) + SizeOf(unicode) 
				Next x
				; Bytes to skip
				WriteLong(ifile, z)
				DisplayWindows::Editor_Text2(#crWhite, "language " + Str(LanguageCount) + ": " + Str(z) + " bytes To skip." + #CRLF$)
				For x = 1 To NumberOfColors
					a = Len(ColorDescription((LanguageCount * 3), x - 1)) 
					b = Len(ColorDescription((LanguageCount * 3) + 1, x - 1)) 
					c = Len(ColorDescription((LanguageCount * 3) + 2, x - 1)) 
					WriteUnicodeCharacter(Ifile, a)	
					WriteUnicodeCharacter(Ifile, b)
					WriteUnicodeCharacter(Ifile, c)
					Debug Str(a) + ":" + ColorDescription((LanguageCount * 3), x - 1)
					Debug Str(b) + ":" + ColorDescription((LanguageCount * 3) + 1, x - 1)
					Debug Str(c) + ":" + ColorDescription((LanguageCount * 3) + 2, x - 1)
					
					WriteString(Ifile, ColorDescription((LanguageCount * 3), x - 1), #PB_Unicode)
					WriteString(Ifile, ColorDescription((LanguageCount * 3) + 1, x - 1), #PB_Unicode)
					WriteString(Ifile, ColorDescription((LanguageCount * 3) + 2, x - 1), #PB_Unicode)
				Next x
			Next LanguageCount
		Else	
			*ErrorData\ErrorNumber = #io_err_CouldNotOpenFile
			ProcedureReturn #False
		EndIf
		ProcedureReturn #True
	EndProcedure
	
		;--- Single Word Parser
	Procedure.i SingleWordParser(ifile.i, FileNameAndPath.s, *ErrorData.ErrorReplay)
		Protected.s Text
		Protected.i LineCounter, LanguageCounter
		Protected.i FileIndex
		Protected.i x, z
		Protected.s Dim Parsed(0)
		SingleWordCount = 0
		If Not win32::FileExist(FileNameAndPath)
	        ProcedureReturn #io_err_file_not_found
	    EndIf
	    FileIndex = ReadFile(#PB_Any, FileNameAndPath, #PB_File_NoBuffering | #PB_Ascii)
	    Repeat
	    	If Eof(FileIndex)
	    		CloseFile(Fileindex)
	    		Break
	    	EndIf	
	        LineCounter + 1
	        Text = ReadString(FileIndex, #PB_Ascii)
	        If LineCounter > 3
	        	Stringsplit(Text, z, Parsed, #TAB$, x)
	        	If z = 2
	        		If Len(parsed(1)) > 0 And Len(parsed(2)) > 0
		        		ReDim Singlewords(#LANG_End, SingleWordCount)
		        		Singlewords(#LANG_Nor, SingleWordCount) = parsed(1)
		        		SingleWords(#LANG_Eng, SingleWordCount) = Parsed(2)
			        	SingleWordCount + 1
		        	EndIf
	        	Else	
	        		*ErrorData\LineNumber = LineCounter
	        		*ErrorData\ErrorNumber = #io_err_data_Structure_Error
	        	EndIf
	        EndIf	
	    ForEver
	    If SingleWordCount
		    For LanguageCounter = 0 To #LANG_END
		    	x = 0
		    	For z = 1 To SingleWordCount
		    		x + StringByteLength(Singlewords(LanguageCounter, z - 1), #PB_Unicode) + SizeOf(unicode)
				Next z	     	
				WriteLong(Ifile, x)
		     	For z = 1 To SingleWordCount
		     		x = Len(Singlewords(LanguageCounter, z - 1))
		     		WriteUnicodeCharacter(ifile, x)
		     		WriteString(ifile, Singlewords(LanguageCounter, z - 1), #PB_Unicode)
		     	Next z
		     Next LanguageCounter
		EndIf     
		ProcedureReturn #True
	EndProcedure
	
	Procedure.s WeaponDamageToString(*Damage.Damage)
		Protected.s Text
		With *Damage
			If (\wAddMagic + \wAddRandom + \wAddStatic)
				Text = Str(\wStatic) + "-" + Str(\wStatic + \wRandom)
				If \wAddMagic
					Text + "(" + Str(\wAddMagic) + ")"
				EndIf
				If (\wAddStatic + \wAddRandom + \wAddMagic)
					Text + " & " + Str(\wAddStatic) + "-" + Str(\wAddStatic + \wAddRandom)
					If \wAddMagic
						Text + "(" + Str(\wAddMagic) + ")"
					EndIf
				EndIf
			Else
				Text = "None."
			EndIf
		EndWith
		ProcedureReturn Text
	EndProcedure
	
	Procedure ShowWeapons(index.i)
		Protected.i Languages	
		Protected.s Text
		For Languages = 0 To #LANG_END
			DisplayWindows::Editor_Text2(#crBlack, "language: ")
			DisplayWindows::Editor_Text2(#crWhite, StringField(#Languages$, Languages + 1, " ") + #CRLF$)
			DisplayWindows::Editor_Text2(#crRed, #line$ + #CRLF$)
			DisplayWindows::Editor_Text2(#crWhite, "Name: ")
			DisplayWindows::Editor_Text2(#crRed, gWeaponNAME(Languages, Index) + #CRLF$)
			DisplayWindows::Editor_Text2(#crWhite, "Description: ")
			DisplayWindows::Editor_Text2(#crRed, gWeaponDesc(Languages, Index) + #CRLF$)
			DisplayWindows::Editor_Text2(#crRed, #line$ + #CRLF$)
			DisplayWindows::Editor_Text2(#crWhite, "Requirements(Str/Dex/Size/Height): " + #CRLF$)
			With gWeaponsData(index)
				Text = Str(\ReqStrength) + "/" + Str(\ReqDexterity) + "/" + Str(\ReqSize) + "/" + Str(\ReqHeight)
			EndWith
			DisplayWindows::Editor_Text2(#crRed, Text + #CRLF$)
			DisplayWindows::Editor_Text2(#crRed, #line$ + #CRLF$)
			DisplayWindows::Editor_Text2(#crBlue, "Melee Damage: ")
			Text = WeaponDamageToString(@gWeaponsData(Index)\Melee)
			DisplayWindows::Editor_Text2(#crRed, Text + #CRLF$)
			
			DisplayWindows::Editor_Text2(#crBlue, "Missile Damage: ")
			Text = WeaponDamageToString(@gWeaponsData(Index)\Missile)
			DisplayWindows::Editor_Text2(#crRed, Text + #CRLF$)
		Next languages	
	EndProcedure

	Procedure ShowCreatures(Index.i)
		Protected.s Text
		Protected.i x, z
		Text = "Racetype: " + Str(Creature(index)\RaceClass) + ", " 
		Text + "Race: " + Str(creature(index)\Race) + ", "
		Text + "Movement : " + Str(Creature(index)\Movement) + ", "
		Text + "Critical Areas : " + Str(Creature(index)\CritAreas[0]) + "/" + Str(Creature(index)\CritAreas[1]) + "/" + Str(Creature(index)\CritAreas[2]) + "/" + Str(Creature(index)\CritAreas[3]) + #CRLF$
		DisplayWindows::Editor_TextColor(#crWhite)
		DisplayWindows::Editor_Text(Text)
		DisplayWindows::Editor_TextColor(#crRed)
		DisplayWindows::Editor_Text(#Line$ + #CRLF$)
		DisplayWindows::Editor_TextColor(#crBlue)
		Text = ""
		For x = 1 To #CreaturesAttributes
			With creature(Index)\stat[x - 1]
				Text + StringField(#StatNames$, x, " ") + ": " + Str(\NumberOfDices) + "D" + Str(\TypeOfDice)
				If \AddToResult
					Text + "+" + Str(\AddToResult)
				EndIf
			EndWith
			Text + #CRLF$
		Next x
		DisplayWindows::Editor_Text(Text)
		DisplayWindows::Editor_TextColor(#crRed)
		DisplayWindows::Editor_Text(#Line$ + #CRLF$)
		DisplayWindows::Editor_TextColor(#crBlue)
		Text = ""
		For z = 1 To 4
			Text + StringField(#ArmorStyles$, z, " ") + ": "
			For x = 1 To #HumanoidZones
				With creature(Index)
					Select z
					Case 1
						Text + Str(\Distributed[x - 1])
					Case 2
						Text + Str(\Penalty[x - 1])
					Case 3
						Text + Str(\NaturalArmor[x - 1])
					Case 4
						Text + Str(\Bleeds[x - 1])
					EndSelect
					If x < #HumanoidZones
						Text + " "
					Else
						Text + #CRLF$
					EndIf
				EndWith
			Next x
		Next z
		DisplayWindows::Editor_Text(Text)
	EndProcedure	
	
	Procedure LoaderString(*ls.ls)
		Protected.i x,z, IdentFlag
		Protected.a BytData
		Protected.s NewString, sTemp
		x = FindString(*Ls\Text,",",1)
		If x
		    *Ls\Language = Val(Left(*Ls\Text, x - 1))
		    *Ls\Text = Mid(*Ls\Text,x + 1)
		    If (Left(*Ls\Text,1) = #DQUOTE$) And (Right(*Ls\Text,1) = #DQUOTE$)
		        *Ls\Text = Mid(*Ls\Text,2,Len(*Ls\Text) - 2)
		    EndIf
		    x = 1
		    z = Len(*Ls\Text)
		    Repeat
		        If x > z
		           If IdentFlag = 1
		               NewString + sTemp
		           EndIf
		           Break
		        EndIf
		        BytData = Asc(Mid(*Ls\Text,x,1))
		        If BytData = #ascPercentage
		            Select IdentFlag
		            Case 0
		                IdentFlag = 1
		            Case 1
		                IdentFlag = 0
		                Select LCase(sTemp)
		                Case "cr" ; Enter
		                    sTemp = #CRLF$
		                Case "dq" ; "
		                    sTemp = #DQUOTE$
		                Default
		                    sTemp = Chr(#ascPercentage) + sTemp + Chr(#ascPercentage) ; unknown. keep it
		                EndSelect
		                newString + sTemp
		                sTemp = ""
		            EndSelect
		        Else
		            Select IdentFlag
		            Case 0
		                NewString + Chr(BytData)
		            Case 1
		                sTemp + Chr(BytData)
		            EndSelect
		        EndIf
		        x + 1
		    ForEver
		    *Ls\Text = NewString
		EndIf
	EndProcedure

Procedure.l SeparateCommand(*Text.SeparateCommand)
    Protected.i x
    x = FindString(*text\Parameter, "=",1)
    If Not x
        ; error
        ProcedureReturn #False
    EndIf
    *text\Command = LCase(Left(*text\Parameter , x - 1))
    *text\Parameter = Mid(*text\Parameter,x + 1)
    ProcedureReturn #True
EndProcedure

Procedure.i isPureNumber(text.s)
	Protected.i CharValue, x
	Text = Trim(text)
	If Len(text)
		For x = 1 To Len(text)
			CharValue = Asc(Mid(text,x,1))
			If CharValue < #NUMERIC0 Or CharValue > #NUMERIC9
				ProcedureReturn #False
			EndIf
		Next x
	Else
		ProcedureReturn #False
	EndIf
	ProcedureReturn #True
EndProcedure

Procedure.i SkipLine(*Skip.Skipline) 
    Protected strLength.i
    strLength = Len(*skip\TextData)
    If Not strLength
        ProcedureReturn #True
    EndIf

    If Asc(*Skip\TextData) = #ascInchSign ; equals "'"
        ProcedureReturn #True
    EndIf
    
    ; If / is in the beginning or end it means the spaces in the end or beginning has to stay
    Select *Skip\wSpace
    Case 1
        ; Checks last char
        If Asc(Right(*Skip\TextData,1)) = #ascLeftSlash ; Checks last char
            *Skip\TextData = Left(*Skip\TextData, strLength - 1)
        EndIf

        If Asc(*Skip\TextData) = #ascLeftSlash
            *Skip\TextData = Mid(*Skip\TextData, 2)
        EndIf
    Case 2
        If Asc(Right(*Skip\TextData, 1)) = #ascUnderScore ; Checks last char
            *Skip\TextData = Mid(*Skip\TextData, 2)
        EndIf
    EndSelect
    
    ; if the line starts with >, line should be dropped

    If *Skip\wLevel = 1
        If Asc(*Skip\TextData) = #ascMostLeft
            ProcedureReturn #True
        EndIf
    EndIf
    ProcedureReturn #False
EndProcedure

Procedure.i WriteFileString(fileIdentifier.i, StringToWrite.s)
	Protected.i x
	x = Len(StringToWrite)
	If WriteUnicodeCharacter(fileIdentifier, x)
		If WriteString(fileIdentifier, StringToWrite)
			ProcedureReturn #True
		EndIf
	EndIf
	ProcedureReturn #False
EndProcedure

Procedure.i CreateWeaponSkills(FileIndex.i, *ErrorData.ErrorReplay)
	Protected.i Counted
	Protected.i x, y, LanguageCount
	Protected.l TotalSkillsCounted, TextlengthTotal
	Protected.i SourceFileNumber
	Protected.s Text
	Protected.s Dim Textdata(0)
	Protected.weaponskillsEx Dim weaponskillsEx(0)
	;###
	;## Read datafile
	;###
	SourceFileNumber = ReadFile(#PB_Any, #RootSource$ + #File1$, #PB_File_NoBuffering | #PB_Ascii)
	If SourceFileNumber
		TotalSkillsCounted = 0
		Repeat
			If Eof(SourceFileNumber) : Break : EndIf
			Text = ReadString(SourceFileNumber, #PB_Ascii)
			Counted = CountString(Text, #TAB$)
			If Counted <> #WeaponSkillsCount
				*ErrorData\ErrorNumber = #FileStructure
				ProcedureReturn #False
			EndIf
			Dim Textdata(Counted)
			For x = 0 To Counted
				Textdata(x) = StringField(Text, x + 1, #TAB$)
			Next x
			If isPureNumber(Textdata(0))
				ReDim weaponskillsex(TotalSkillsCounted)
				With weaponskillsEx(TotalSkillsCounted)
					\ID = Val(Textdata(0))
					\BaseAttackSkill = Val(Textdata(1))
					\BaseParrySkill = Val(Textdata(2))
					\Language[#destlanguageNorwegian] = Textdata(3)
					\Language[#destlanguageEnglish] = Textdata(4)
				EndWith
				TotalSkillsCounted + 1
			EndIf
		ForEver
		CloseFile(SourceFileNumber)
		;###
		;## Write datafile
		;###
		DisplayWindows::Editor_TextColor(#crMagenta)
		DisplayWindows::Editor_Text("Number of Weaponskills: " + Str(TotalSkillsCounted) + #CRLF$)
		For x = 1 To TotalSkillsCounted
			y = x - 1
			; ID
			WriteLong(FileIndex,weaponskillsEx(y)\ID)
			; Base Skill Attack
			WriteUnicodeCharacter(FileIndex, weaponskillsEx(y)\BaseAttackSkill)
			; Base Skill Parry
			WriteUnicodeCharacter(FileIndex, weaponskillsEx(y)\BaseParrySkill)
		Next x
		For LanguageCount = #DestLanguageFirst To #DestLanguageLast 
			;### Get length
			TextlengthTotal = 0
			For x = 1 To TotalSkillsCounted
				y = x - 1
				TextlengthTotal + StringByteLength(weaponskillsEx(y)\Language[LanguageCount],#PB_Unicode) + SizeOf(character)
			Next x
			;### Write length
			WriteLong(FileIndex, TextlengthTotal)				
			For x = 1 To TotalSkillsCounted
				y = x - 1				
				WriteUnicodeCharacter(FileIndex, Len(weaponskillsEx(y)\Language[LanguageCount]))
				WriteString(FileIndex, weaponskillsEx(y)\Language[LanguageCount])
			Next x
			DisplayWindows::Editor_TextColor(#crBlue)
			DisplayWindows::Editor_Text("Language (" + Str(LanguageCount) + "), Numbers of byte set to: " + Str(TextlengthTotal) + #CRLF$)
		Next LanguageCount
		ProcedureReturn #True
	Else	
		*ErrorData\FileName = #File1$
		*ErrorData\ErrorNumber = #FileNotFound
		*ErrorData\FileToCloseNumber = 0
	EndIf
	ProcedureReturn #False
EndProcedure
;--- Creatures Parser
Procedure.i ParseCreatures(DestFileNumber.i, *ErrorData.ErrorReplay)
	Protected.i iFile
	Protected.s OrigDataFile
	Protected.i x, y, LineCounter
	Protected.s strData , strArgument, IdString
	Protected.s Dim wk(0)
	Protected.w lv, rv
	Protected.l CreatureCounter, CreateIndex
	Protected.Skipline Skip
	Protected.i UpperBound
	Protected.l lError
	*ErrorData\ErrorNumber       = 0
	*ErrorData\FileToCloseNumber = 0
	*ErrorData\LineNumber = 0
	OrigDataFile = #RootSource$ + #File2$
	*ErrorData\FileName = OrigDataFile
	If win32::FileExist(OrigDataFile)
		iFile = ReadFile(#PB_Any, OrigDataFile, #PB_File_NoBuffering | #PB_Ascii)
		If ifile
			;####
			; Read File
			;####
			Dim Creature(0)
			CreateIndex     = -1
			CreatureCounter = 0
			*ErrorData\LineNumber = 0
	        Repeat
	        	*ErrorData\ErrorNumber       = 0
	        	*ErrorData\FileToCloseNumber = 0
	        	If Eof(ifile)
	        		Break
	            EndIf
	            strdata = ReadString(ifile, #PB_Ascii)
	            skip\TextData = strdata
	            skip\wLevel = 0
	            skip\wSpace = 0
	            If Not skipline(@skip)
	            	x = FindString(Strdata, "=", 1, #PB_String_NoCase)
                    If x > 0
                        IdString = LCase(Left(strData,x - 1))
                        strArgument = Mid(strdata,x + 1)
                        Select IdString
                        Case "racetype"
                        	CreatureCounter + 1
                        	CreateIndex + 1
                            ReDim Creature(CreateIndex)
                            Select LCase(strArgument)
                            Case "humanoid"
                                Creature(CreateIndex)\HitLocations = 8
                            Case "humanoid_skeleton"
                                Creature(CreateIndex)\HitLocations = 8
                            EndSelect
                            Creature(CreateIndex)\Raceclass = Val(strArgument)
                        Case "race"
                            Creature(CreateIndex)\race = Val(strArgument)
                        Case "stat"
                        	Stringsplit(strArgument, UpperBound, wk, ",", x)
                            strArgument = wk(0)
                            If UpperBound = 3
	                            ;  Creature(CreateIndex)\StatLowest
	                            Select LCase(strArgument)
	                            Case "str"
	                            	x = #STAT_STRENGTH
	                            Case "con"
	                            	x = #STAT_CONSTITUTION
	                            Case "siz"
	                            	x = #STAT_SIZE
	                            Case "int"
	                            	x = #STAT_INTELLIGENCE
	                            Case "pow"
	                            	x = #STAT_POWER
	                            Case "dex"
	                            	x = #STAT_DEXTERITY
	                            Case "app"
	                            	x = #STAT_APPEARANCE
	                            Default	
	                            	*ErrorData\ErrorNumber = #io_err_UnknownControlCode
	                            	lError = #True
	                            	Break
	                            EndSelect
	                            With Creature(CreateIndex)\stat[x]
	                            	\NumberOfDices   = Val(wk(1))
	                            	\TypeOfDice      = Val(wk(2))
	                            	\AddToResult     = Val(wk(3))
	                            EndWith
	                        Else
	                        	lError = #True
	                        	*ErrorData\ErrorNumber = #io_err_data_Structure_Error
	                        	Break
	                        EndIf
                        Case "distributed"
                        	Stringsplit(strArgument, UpperBound, wk, ",", x)
                            For x = 0 To UpperBound
                                Creature(CreateIndex)\Distributed[x] = Val(Trim(wk(x)))
                            Next x
                        Case "penalty"
                        	Stringsplit(strArgument, UpperBound, wk, ",", x)
                            For x = 0 To UpperBound
                                Creature(CreateIndex)\Penalty[x] = Val(Trim(wk(x)))
                            Next x
                        Case "critareas"
                        	Stringsplit(strArgument, UpperBound, wk, ",", x)
                            Creature(CreateIndex)\CritLocations = Val(wk(0))
                            If UpperBound <> (Val(wk(0)))
                                lError = #True
                                Break
                            Else
                                For x = 0 To UpperBound
                                  Creature(CreateIndex)\CritAreas[x] = Val(wk(x))
                                Next x
                            EndIf
                        Case "bleeds"
                        	Stringsplit(strArgument, UpperBound, wk, ",", x)
                            For x = 0 To UpperBound
                                Creature(CreateIndex)\Bleeds[x] = Val(Trim(wk(x)))
                            Next x
                        Case "armor"
                        	Stringsplit(strArgument, UpperBound, wk, ",", x)
                            For x = 0 To UpperBound
                                Creature(CreateIndex)\NaturalArmor[x] = Val(Trim(wk(x)))
                            Next x
                        Case "movement"
                            Creature(CreateIndex)\Movement = Val(Trim(strArgument))
                        Case "chaos"
                            Creature(CreateIndex)\Chaos = Val(Trim(strArgument))
                        EndSelect
                    EndIf
                EndIf
            	LineCounter + 1
            ForEver
	    Else
	    	lError = #True
	    	*ErrorData\ErrorNumber = #io_err_CouldNotOpenFile
	    EndIf
	Else    
	    lError = #True
	    *ErrorData\ErrorNumber = #io_err_file_not_found
	EndIf
    CloseFile(iFile) 
    If lerror
	    *ErrorData\LineNumber = LineCounter + 1
		ProcedureReturn #False
	EndIf
	DisplayWindows::Editor_TextColor(#crLime)
	DisplayWindows::Editor_Text("Writing " + Str(CreateIndex + 1) + " Binary Creature data." + #CRLF$)
    ; Save Anatomy
    ; output numbers of Creatures
    ; we write all Creature data out
	For x = 0 To CreateIndex
		WriteData(DestFileNumber, @Creature(x), SizeOf(Entities))
	Next x
	ShowCreatures(0)
	ShowCreatures(CreateIndex)
    ProcedureReturn #True
EndProcedure
;--- Civil skill parser
Procedure CreateCivilSkill(DestFileNumber.i, *ErrorData.ErrorReplay)
	Protected.i iFile
	Protected.s OrigDataFile
	Protected.i x, y, LineCounter
	Protected.s strData , strArgument, IdString
	Protected.s Dim Parsed(0)
	Protected.l lError
	Protected.i CivilIndex
	Protected.Skipline Skip
	Protected.a A1,A2,A3
	Protected.civil Dim Civil(0)
	Protected.i LanguageCount
	Protected.i WriteOffset
	;Protected.i TextLengthChar, TextLengthByte, TextlengthTotal
	OrigDataFile = #RootSource$ + #File3$
	*ErrorData\FileName = OrigDataFile
	*ErrorData\FileToCloseNumber = 0
	*ErrorData\ErrorNumber = #io_err_all_ok
	*ErrorData\LineNumber = 0
	lError = #False
	If win32::FileExist(OrigDataFile)
		iFile = ReadFile(#PB_Any, OrigDataFile, #PB_File_NoBuffering | #PB_Ascii)
		If ifile
	        Repeat
	            If Eof(ifile)
	                Break
	            EndIf
	            *ErrorData\LineNumber + 1
	            strdata = ReadString(ifile, #PB_Ascii)
	            skip\TextData = strdata
	            skip\wLevel = 0
	            skip\wSpace = 0
	            If Not skipline(@skip) And *ErrorData\LineNumber >= 4
	            	y = CountString(Strdata, #TAB$)
       				Dim Parsed(y)
       				If y >= 7
       					For x = 0 To y
							Parsed(x) = StringField(strData, x + 1, #TAB$)
						Next x
						If isPureNumber(Parsed(0))
							ReDim Civil(CivilIndex)
							A1 = Val(parsed(2))
							A2 = Val(parsed(3))
							A3 = Val(parsed(4))
							If A2
								A1 | 2
							EndIf
							If A3
								A1 | 4
							EndIf
							With Civil(CivilIndex)
								\id   = Val(parsed(0))
								\Groupid = Val(Parsed(1))
								\Base = Val(Parsed(5))
								\Flag = A1
								\Language[#destlanguageNorwegian] = Parsed(6)
								\Language[#destlanguageEnglish]   = Parsed(7)
							EndWith
							CivilIndex + 1
						EndIf
					Else	
						*ErrorData\ErrorNumber = #io_err_data_Structure_Error
						lError = #True
						Break
					EndIf
				EndIf
			ForEver
			CloseFile(ifile)
			DisplayWindows::Editor_Text2(#crBlue, "Civil Skills Count: " + Str(CivilIndex) + #CRLF$)
		Else	
			*ErrorData\ErrorNumber = #io_err_CouldNotOpenFile
			lError = #True	
		EndIf
	EndIf
	If lError
		ProcedureReturn #False
	EndIf
	
	For x = 1 To CivilIndex
		y = x - 1
		With Civil(y)
			WriteLong(DestFileNumber, \id)
			WriteUnicodeCharacter(DestFileNumber, \Groupid)
			WriteAsciiCharacter(DestFileNumber, \Flag)
			WriteUnicodeCharacter(DestFileNumber, \Base)
		EndWith
	Next x
	For LanguageCount = #DestLanguageFirst To #DestLanguageLast 
		WriteOffset = 0
		For x = 1 To CivilIndex
			y = x - 1
			With civil(y)
				WriteOffset + StringByteLength(\Language[LanguageCount], #PB_Unicode) + SizeOf(Character)
			EndWith
		Next x
		WriteLong(Destfilenumber, WriteOffset)
		DisplayWindows::Editor_TextColor(#crBlue)
		DisplayWindows::Editor_Text("Language (" + Str(LanguageCount) + "), Numbers of byte set to: " + Str(WriteOffset) + #CRLF$)
		For x = 1 To CivilIndex
			y = x - 1
			With civil(y)
				WriteUnicodeCharacter(DestFileNumber, Len(\Language[LanguageCount]))
				WriteString(DestFileNumber, \Language[LanguageCount])
			EndWith
		Next x
	Next LanguageCount
	ProcedureReturn #True
EndProcedure	            	

;--- Item Parser
Procedure.i ItemParser(iFile.i, FileNameAndPath.s, *ErrorData.ErrorReplay)
Protected.i FileIndex, UpperBound
Protected.l Level
Protected.s Dim Parsed(0)
Protected.i x, z, y, Lang
Protected.l Result
Protected.i LineCounter
Protected.SeparateCommand Sepcom
Protected.ls ls

If Not win32::FileExist(FileNameAndPath)
        ProcedureReturn #io_err_file_not_found
    EndIf
    FileIndex = ReadFile(#PB_Any, FileNameAndPath, #PB_File_NoBuffering | #PB_Ascii)
    Repeat
    	If Eof(FileIndex)
    		Break
    	EndIf	
        LineCounter + 1
        sepcom\Parameter = ReadString(FileIndex, #PB_Ascii)
        If Left(sepcom\Parameter,1) <> "'" And Len(Trim(sepcom\Parameter))
            If Left(sepcom\Parameter,1) = "."
                Select LCase(sepcom\Parameter)
                Case ".begin_compile"
                    level = 1
                Case ".end_compile"
                    level = 0
                Case ".begin_weapon"
                    ;msg_Debug "Begin Weapon: " + str(EquipmentTotal\Weapons))
                    Level = 2
                Case ".end_weapon"
                	EquipmentTotal\Weapons + 1
                    Level = 0
                Case ".begin_armor"
                    Level = 3
                    ;msg_Debug "Begin Clothing: " + str(EquipmentTotal\Clothings))
                Case ".end_armor"
                	EquipmentTotal\Clothings + 1
                    Level = 0
                Case ".begin_enchantments"
                    Level = 4
                Case ".end_enchantments"
                    Level = 0
                Case ".begin_enchantmentsnames"
                    Level = 5
                Case ".end_enchantmentsnames"
                    Level = 0
                EndSelect
            Else
            	Select level
                Case 1 ; Compile Version
                	If Not SeparateCommand(@sepcom) ; dcommand is returned as lowercase
                        Result = #io_err_data_Structure_Error
                        Break
                    EndIf
                    Select Sepcom\Command
                    Case "version"
                        Default_TempCompileVersion = Val(sepcom\Parameter)
                    Case "increment"
                        Default_TempCompileIncrements = Val(sepcom\Parameter)
                    Case "weapons"
                        z = Val(sepcom\Parameter)
                        If EquipmentTotal\Weapons
                            z + EquipmentTotal\Weapons
                        Else
                            z - 1
                        EndIf
                        ReDim gWeaponsData(z)
                        ReDim gWeaponNAME(#LANG_END, z)
                        ReDim gWeaponDesc(#LANG_END, z)
                        DisplayWindows::Editor_TextColor(#crPink)
                        DisplayWindows::Editor_Text("Weapons: " + Str(z + 1) + #CRLF$)
                    Case "enchantmentgroups"
                        z = Val(sepcom\Parameter)
                        If EquipmentTotal\EnchantmentGroups
                            z + EquipmentTotal\EnchantmentGroups
                        Else
                            z - 1
                        EndIf
                        ReDim gEnchantmentGroups(z)
                        DisplayWindows::Editor_TextColor(#crPink)
                        DisplayWindows::Editor_Text("Enchantment Groups: " + Str(z + 1) + #CRLF$)
                    Case "enchantments"
                        z = Val(sepcom\Parameter)
                        If EquipmentTotal\Runes
                            z + EquipmentTotal\Runes
                        Else
                            z - 1
                        EndIf
                        ReDim Runes(z)
                        DisplayWindows::Editor_TextColor(#crPink)
                        DisplayWindows::Editor_Text("Enchantment Runes: " + Str(z + 1) + #CRLF$)
                    Case "armors"
                        z = Val(sepcom\Parameter)
                        If EquipmentTotal\Clothings
                            z + EquipmentTotal\Clothings
                        Else
                            z - 1
                        EndIf
                        ReDim gClothingName(#LANG_END, z)
                        ReDim gClothingDesc(#LANG_END, z)
                        ReDim gClothing(z)
                        DisplayWindows::Editor_TextColor(#crPink)
                        DisplayWindows::Editor_Text("Armors: " + Str(z + 1) + #CRLF$)
                        
                EndSelect
                Case 2 ; Weapons
                	If Not SeparateCommand(@sepcom) ; dcommand is returned As lowercase
                        Result = #io_err_data_Structure_Error
                        Break
                    EndIf
                    Select sepcom\Command
                    Case "name"
                    	ls\Text = Sepcom\Parameter
                    	ls\Language = lang
                    	LoaderString(@ls)
                    	gWeaponNAME(ls\Language, EquipmentTotal\Weapons) = ls\Text
                    Case "id"
                        gWeaponsData(EquipmentTotal\Weapons)\itemID = Val(sepcom\Parameter)
                    Case "colors"
                        Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
                        If UpperBound <> 4
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        For y = 1 To #WeaponMaxColors
                        	x = y - 1
                        	gWeaponsData(EquipmentTotal\Weapons)\Colours[x] = Val(parsed(x))
                        Next y
                    Case "runes"
                        Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
                        If UpperBound <> 1
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        gWeaponsData(EquipmentTotal\Weapons)\enchID = Val(parsed(0))
                        gWeaponsData(EquipmentTotal\Weapons)\EnchValue = Val(parsed(1))
                    Case "geas"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 1
							Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        gWeaponsData(EquipmentTotal\Weapons)\GeasEnchID = Val(parsed(0))
                        gWeaponsData(EquipmentTotal\Weapons)\GeasEnchValue = Val(parsed(1))
                    Case "range"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 3
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        With gWeaponsData(EquipmentTotal\Weapons)
	                        \RngShort    = Val(Parsed(0))
	                        \RngMedium   = Val(Parsed(1))
	                        \RngLong     = Val(Parsed(2))
	                        \RngMax      = Val(Parsed(3))
                        EndWith
                    Case "desc"
                     	ls\Text = sepcom\Parameter
                    	ls\Language = lang
                    	LoaderString(@ls)
                        gWeaponDesc(ls\Language, EquipmentTotal\Weapons) = ls\Text
                    Case "category"
                        gWeaponsData(EquipmentTotal\Weapons)\WeaponFlags = Val(sepcom\Parameter)
                    Case "group"
                        gWeaponsData(EquipmentTotal\Weapons)\Group = Val(sepcom\Parameter)
                    Case "handsrequired"
                        gWeaponsData(EquipmentTotal\Weapons)\ReqHands = Val(sepcom\Parameter)
                    Case "req"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 3
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        With gWeaponsData(EquipmentTotal\Weapons)
                        	\ReqStrength    = Val(Parsed(0))
                        	\ReqDexterity   = Val(Parsed(1))
                        	\ReqSize        = Val(Parsed(2))
                        	\ReqHeight      = Val(Parsed(3))
                        EndWith
                    Case "tech"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 2
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        With gWeaponsData(EquipmentTotal\Weapons)
	                        \Length = Val(Parsed(0))
	                        \Weight = Val(Parsed(1))
	                        \Value  = Val(Parsed(2))
                        EndWith
                    Case "meleedam"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 5
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        
                        With gWeaponsData(EquipmentTotal\Weapons)\Melee
                        	\wStatic      = Val(Parsed(0))
                        	\wRandom      = Val(Parsed(1))
                        	\wMagic       = Val(Parsed(2))
                        	\wAddStatic   = Val(Parsed(3))
                        	\wAddRandom   = Val(Parsed(4))
                        	\wAddMagic    = Val(Parsed(5))
                        EndWith
                    Case "missiledam"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 5
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        
                        With gWeaponsData(EquipmentTotal\Weapons)\Missile
                        	\wStatic      = Val(Parsed(0))
                        	\wRandom      = Val(Parsed(1))
                        	\wMagic       = Val(Parsed(2))
                        	\wAddStatic   = Val(Parsed(3))
                        	\wAddRandom   = Val(Parsed(4))
                        	\wAddMagic    = Val(Parsed(5))
                        EndWith
                    EndSelect
                Case 3 ; armor/clothing
                	If Not SeparateCommand(@sepcom) ; dcommand is returned as lowercase
                        Result = #io_err_data_Structure_Error
                        Break
                    EndIf
                    Select sepcom\Command
                    Case "name"
                     	ls\Text = sepcom\parameter
                    	ls\Language = lang
                    	LoaderString(@ls)
                    	sepcom\parameter = ls\Text
                        gClothingName(lang, EquipmentTotal\Clothings) = sepcom\parameter
                    Case "id"
                        gClothing(EquipmentTotal\Clothings)\Itemid = Val(sepcom\Parameter)
                    Case "type"
                        gClothing(EquipmentTotal\Clothings)\itemtype = Val(sepcom\Parameter)
                    Case "szclass"
                        gClothing(EquipmentTotal\Clothings)\Sizeclass = Val(sepcom\Parameter)
                    Case "colors"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 4
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        For y = 1 To #ClothingMaxColors
                        	x = y - 1
                        	gClothing(EquipmentTotal\Clothings)\Colours[x] = Val(Parsed(x))
                        Next y
                    Case "runes"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 1
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        gClothing(EquipmentTotal\Clothings)\enchID = Val(parsed(0))
                        gClothing(EquipmentTotal\Clothings)\EnchValue = Val(parsed(1))
                    Case "geas"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 1
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        gClothing(EquipmentTotal\Clothings)\GeasEnchID = Val(parsed(0))
                        gClothing(EquipmentTotal\Clothings)\GeasEnchValue = Val(parsed(1))
                    Case "desc"
                     	ls\Text = sepcom\parameter
                    	ls\Language = lang
                    	LoaderString(@ls)
                    	sepcom\parameter = ls\Text
                        gClothingDesc(lang, EquipmentTotal\Clothings) = sepcom\parameter
                    Case "weight"
                        gClothing(EquipmentTotal\Clothings)\Weight = Val(sepcom\Parameter)
                    Case "value"
                        gClothing(EquipmentTotal\Clothings)\Value = Val(sepcom\Parameter)
                    Case "location"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 4
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        x = 0 : z = 0
                        parsed(0) = LCase(parsed(0))
                        Repeat
                            If x = 8 : Break : EndIf
                            If Mid(#Locations$, (x * 2) + 1, 2) = parsed(0)
                                z = 1
                                Break
                            EndIf
                            x + 1
                        ForEver
                        If z = 0
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        With gClothing(EquipmentTotal\Clothings)
	                        \UsedSlot[x]                       = 1 							   ; in use
	                        \ArmorValue[x]                     = Val(parsed(1))
	                        \EnchantedArmorValue[x]            = Val(parsed(2))                ; EAL
	                        \ArmorType[x]                      = Val(parsed(3))                ; Armortype
	                        \DescCover[x]                      = Val(parsed(4))				   ; Description & cover
                        EndWith
                    EndSelect
                Case 4 ; Enchantments groups
                    If Not SeparateCommand(@Sepcom) ; dcommand is returned As lowercase
                        Result = #io_err_data_Structure_Error
                        Break
                    EndIf
                    Select sepcom\Command
                    Case "enchantment","groupid"
						Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
						If UpperBound <> 1
                            Result = #io_err_data_Structure_Error
                            Break
                        EndIf
                        gEnchantmentGroups(EquipmentTotal\EnchantmentGroups)\groupid = Val(Parsed(0))
                        gEnchantmentGroups(EquipmentTotal\EnchantmentGroups)\JumpOrEnchValue = Val(Parsed(1))
                        EquipmentTotal\EnchantmentGroups + 1
                    EndSelect
                Case 5 ; Enchantment group names
					Stringsplit(sepcom\Parameter, UpperBound, Parsed, ",", x)
					If UpperBound <> 1
                        Result = #io_err_data_Structure_Error
                        Break
                    EndIf
                    Runes(EquipmentTotal\Runes)\ID = Val(parsed(0))
                    Runes(EquipmentTotal\Runes)\EnchValue = Val(parsed(1))
                    EquipmentTotal\Runes + 1
                EndSelect
            EndIf
        EndIf
    ForEver
    CloseFile(FileIndex)
    If result <> #io_err_all_ok
    	MessageRequester("Status", "Error: " + Str(result) + ": " + #CRLF$ + "Line:" + Str(LineCounter) + #CRLF$ + "Data: " + sepcom\parameter,#PB_MessageRequester_Ok)
    	*ErrorData\ErrorNumber = Result
    	*ErrorData\FileName = FileNameAndPath
    	ProcedureReturn #False
    EndIf
	;--- Write Items to disc    
    
    WriteData(ifile, @EquipmentTotal, SizeOf(EquipmentTotal))
    
    For y = 1 To EquipmentTotal\Weapons
    	x = y - 1
    	WriteData(ifile,@gWeaponsData(x), SizeOf(ItemDataWeapon))
    Next y
    
    For y = 1 To EquipmentTotal\Clothings
    	x = y - 1
    	WriteData(ifile, @gClothing(x), SizeOf(ItemDataClothing))
    Next y
    
    For y = 1 To EquipmentTotal\EnchantmentGroups
    	x = y - 1
    	WriteData(ifile, @gEnchantmentGroups(x), SizeOf(EnchantmentGroup))
    Next y
    
    For y = 1 To EquipmentTotal\Runes
    	x = y - 1
    	WriteData(ifile, @Runes(x), SizeOf(Rune))
    Next y
    For z = 0 To #LANG_END
    	; Get length of Weapons
    	x = 0
    	For y = 1 To EquipmentTotal\Weapons
    		x + StringByteLength(gWeaponNAME(z, y - 1), #PB_Unicode) + SizeOf(character)
    		x + StringByteLength(gWeaponDesc(z, y - 1), #PB_Unicode) + SizeOf(character)
    	Next y
    	
    	; Add length of Clothing
    	For y = 1 To EquipmentTotal\Clothings
    		x + StringByteLength(gClothingName(z, y - 1), #PB_Unicode) + SizeOf(character)
    		x + StringByteLength(gClothingDesc(z, y - 1), #PB_Unicode) + SizeOf(character)
    	Next y
    	
    	WriteLong(ifile, x)
    	
    	For y = 1 To EquipmentTotal\Weapons
    		WriteUnicodeCharacter(ifile, Len(gWeaponNAME(z, y - 1)))
    		WriteString(ifile, gWeaponNAME(z, y - 1), #PB_Unicode)
    		WriteUnicodeCharacter(ifile, Len(gWeaponDesc(z, y - 1)))
    		WriteString(ifile, gWeaponDesc(z, y - 1), #PB_Unicode)
    	Next y
    	
    	For y = 1 To EquipmentTotal\Clothings
    		WriteUnicodeCharacter(ifile, Len(gClothingName(z, y - 1)))
    		WriteString(ifile, gClothingName(z, y - 1))
    		WriteUnicodeCharacter(ifile, Len(gClothingDesc(z, y - 1)))
    		WriteString(ifile, gClothingDesc(z, y - 1))
    	Next y
    Next z
    ShowWeapons(0)
    ShowWeapons(EquipmentTotal\Weapons - 1)
    ProcedureReturn #True
EndProcedure

Procedure.i main(WritefileID.i)
	Protected.ErrorReplay ErrorData
	DisplayWindows::Editor_Text2(#crMagenta, "------------------- CreateWeaponSkills -------------------" + #CRLF$)
	If Not CreateWeaponSkills(WritefileID, @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf
	DisplayWindows::Editor_Text2(#crMagenta, "------------------- ParseCreatures -------------------" + #CRLF$)
	If Not ParseCreatures(WritefileID, @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crGreen, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf
	DisplayWindows::Editor_Text2(#crMagenta, "------------------- CivilSkill -------------------" + #CRLF$)
	If Not CreateCivilSkill(WritefileID, @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crGreen, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf	
	DisplayWindows::Editor_Text2(#crMagenta, "------------------- ItemParser -------------------" + #CRLF$)
	DisplayWindows::Editor_Text2(#crWhite, "Parsing GameItems.items" + #CRLF$)
	If Not ItemParser(WritefileID, #RootSource$ + "GameItems.items", @Errordata)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf
	DisplayWindows::Editor_Text2(#crWhite, "Parsing SingleWord.csv" + #CRLF$)
	If Not SingleWordParser(WritefileID, #RootSource$ + "SingleWord.csv", @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf	
	DisplayWindows::Editor_Text2(#crWhite, "Parsing ColorAndIDs.csv" + #CRLF$)
	If Not ParseColorDescriptions(WritefileID, #RootSource$ + "ColorAndIDs.csv", @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf
	DisplayWindows::Editor_Text2(#crWhite, "Parsing Hair Descriptions.csv" + #CRLF$)
	If Not ParseHair(WritefileID, #RootSource$ + "Hair.csv", @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf	
	DisplayWindows::Editor_Text2(#crWhite, "Parsing SorcerySpells.csv" + #CRLF$)
	If Not ParseSorcery(WritefileID, #RootSource$ + "SorcerySpells.csv", @ErrorData)
		DisplayWindows::Editor_Text2(#crRed, "Error...." + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Filename: " + ErrorData\FileName + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Error: " + ReturnErrorInText(ErrorData\ErrorNumber) + #CRLF$)
		DisplayWindows::Editor_Text2(#crLime, "Line with Error: " + Str(ErrorData\LineNumber) + #CRLF$)
		ProcedureReturn #False
	EndIf	
	ProcedureReturn #True
EndProcedure

Define.s DestinationName, Header
;Define.s sName, sName2, sName3
Define.q ResultSize
Define.i DestinationFileNumber

DisplayWindows::InformationWindow()
SetGadgetAttribute(DisplayWindows::RTFGagdetHandle, #PB_Editor_WordWrap, #True)
DestinationName = #DestinationFolder$ + #DestinationFile$
ResultSize = FileSize(DestinationName)
If ResultSize >= 0 ; BID File exist. Delete it
    DeleteFile(DestinationName, #PB_FileSystem_Force) ; Delete even if Write protected
EndIf
DestinationFileNumber = CreateFile(#PB_Any, DestinationName, #PB_Unicode | #PB_File_NoBuffering)
If DestinationFileNumber
	Header = "$ver" + Str(#VersionMayor) + "." + Str(#VersionMinor) + ";" + #COMMANDIDENTIFIERHEADER$ + #CR$
	WriteString(DestinationFileNumber,Header, #PB_Ascii)
	DisplayWindows::Editor_TextColor(#crBlue)
	If Main(DestinationFileNumber)
		DisplayWindows::Editor_Text("All done..")
	Else
		DisplayWindows::Editor_Text("Something went wrong")
	EndIf
	CloseFile(DestinationFileNumber)
EndIf
DisplayWindows::DisplayWindowActivity()

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 157
; FirstLine = 369
; Folding = -----
; EnableXP
; Executable = GameDataBuilder2.exe