﻿;--- Weapon/Clothing/Items Structures
	;#####################################
	; Due tro the way [] works, The Max values has to be +1 vs the Powerbasic version
	;#####################################
	
	#WeaponMaxColors             = 5
	#ClothingMaxColors           = 5
	#HumanoidZones               = 8
	Structure Damage
		wStatic.w               ; Minimum damage
		wRandom.w               ; Random added
		wMagic.w                ; Magical added
		wAddStatic.w            ; Minimum damage when impale
		wAddRandom.w            ; Random added damage when impale
		wAddMagic.w             ; Magical added Damage when impale
	EndStructure
	
	Structure ItemDataWeapon
	    ItemID.l                  ; Weapons ID
	    Critical.w                ; Weapons Critical Bonus, if any
	    Special.w                 ; Weapons Special Bonus, if any
	    Impale.w                  ; Weapons Impale Bonus, if any
	    Fumble.w                  ; Weapons fumble Bonus, if any
	    Group.u                   ; Weapons group; 1hsword, 2hsword etc
	    WeaponFlags.a             ; Information about kind of Weapon, Stab, cut, 1h, 2h and so on
	    Value.l                   ; Weapons value
	    ReqStrength.u             ; Required strength to wield it
	    ReqDexterity.u            ; Required dexterity to wield it
	    ReqSize.u                 ; Required Size to wield it
	    ReqHeight.l               ; Required height to wield it
	    Weight.f                  ; Weapons Weight
	    Length.u                  ; Weapons length in cm.
	    DamageCategory.u          ; Weapons WeaponCategory
	    ReqHands.u                ; Numbers of hands required to use it
	    ; Melee Damage
	    Melee.Damage
	    Missile.Damage
	    Ranged.w         		  ; Ranged Weapon? ex. Bow?
	    RngShort.u                ; Short range
	    RngMedium.u               ; Medium Range
	    RngLong.u                 ; Long Range
	    RngMax.u                  ; Max Range. Weapon cannot reach beyond this point
	    RangedDamStatic.w         ; Minimum damage
	    RangedDamRandom.w         ; Random damage to add
	    RangedDamMagical.w        ; Magical added
	    ; Damage if special or better
	    RangedAddDamStatic.w      ; Minimum damage
	    RangedAddDamRandom.w      ; Random damage to add
	    RangedAddDamMagical.w     ; Magical added
	    Bound.l
	    ; used with enchanments
	    EnchID.l
	    EnchValue.l
	    GeasEnchID.l
	    GeasEnchValue.l
	    Colours.w[#WeaponMaxColors]
	EndStructure
	
	Structure ItemDataClothing
	    Bound.l
	    ItemType.l
	    ItemID.l
	    UsedSlot.a[#HumanoidZones]
	    DescCover.a[#HumanoidZones]
	    Colours.u[#ClothingMaxColors]
	    reqStrength.u
	    Sizeclass.u
	    Weight.f
	    Value.l
	    ArmorValue.u[#HumanoidZones]
	    EnchantedArmorValue.u[#HumanoidZones]
	    ArmorType.u[#HumanoidZones]
	    EnchID.l
	    EnchValue.l
	    GeasEnchID.l
	    GeasEnchValue.l
	EndStructure
	
	Structure EnchantmentGroup
		GroupID.l
		JumpOrEnchValue.l
	EndStructure
	
	Structure Rune
    	ID.l
    	EnchValue.l
	EndStructure

	Structure ItemDataWeaponEx Extends ItemDataWeapon
		Name.s
		Description.s
	EndStructure
	
	Structure ItemDataClothingEx Extends ItemDataClothing
		Name.s
		Description.s
	EndStructure
	
	Structure Enchantment
		ID.l
		Name.s
	EndStructure
;--- Character Structures & Constants
	#SureNameLength              = 20
	#MiddleNameLength            = 20
	#LastNameLength              = 20
	#PlayerNameMaxLength         = 30
	#PlayerNickMaxLength         = 30
	#COINTYPES                   = 5  ; // 0 To 4, 5 total
	#NumberOfCharacteristicStats = 7   ; // 0 to 6
	#NumbersOfClasses            = 5
	#MaxClasses                  = 4
	#bzLocationsMax              = 10 ; 10 slots // 0 to 9
	#RIGHT_HAND                  = 1
	#LEFT_HAND                   = 2
	
	#STATB_AGILITY               = 0
	#STATB_COMMUNICATION         = 1
	#STATB_KNOWLEDGE             = 2
	#STATB_MANIPULATION          = 3
	#STATB_PERCEPTION            = 4
	#STATB_STEALTH               = 5
	#STATB_MAGIC                 = 6

	; Location placement on the body for weapons
	#WPRUArm                         = 0
	#WPLUArm                         = 1
	#WPRLArm                         = 2
	#WPLLArm                         = 3
	#WPRThigh                        = 4
	#WPLThigh                        = 5
	#WPRleg                          = 6
	#WPLleg                          = 7
	#WPRHip                          = 8
	#WPLHip                          = 9
	#WPRLBack                        = 10
	#WPLRBack                        = 11
	#WEAPONPLACEMENTTOTAL            = 12
	#CharacterWeaponSlots            = 15
	
	#MaxCharInventoryItems           = 50
	
	Structure Charinventory
	  	IDCode.l       ; Gjenstands kode.
	  	Location.l     ; Gjenstands Lokalisjon.
	EndStructure
	  
	Structure CharWeaponSkills
		Attackbase.u
		AttackStatBonus.u
		AttackMagicBonus.u
		AttackExperience.u
		ParryBase.u	
		ParryStatBonus.u
		ParryMagicBonus.u
		ParryExperience.u
	EndStructure
	
	Structure CharArmor
		Spell.u
		Runes.u
		Physical.u
		Natural.u
	EndStructure
	
	Structure GeneralSkills
		Base.u
		MagicBonus.u	
		StatBonus.u
		Total.u
		Experience.u
		Used.a
	EndStructure
	
	Structure StatAttributes
		Fixed.w
		Magical.w
		Modified.w
		Original.w
	EndStructure
	Structure myPC
		SureName.u[#SureNameLength]
		MiddleName.u[#MiddleNameLength]
		LastName.u[#lastNameLength]
		Age.w
		Alignment.w
		BuildVariations.f
		CharID.l
		CriticalArea.l
		CurrentMove.w
		Defence.w
		DefenceType.w
		Experience.l
		Eyesight.w
		EyeColors.w
		ForcingDown.l
		FootSize_Original.f
		Fumble.l
		Gender.w
		Hairstyle.w
		HairColor.w
		Height.l
		MagicMove.w
		KeepDownFootUsed.w
		HeadHeight.f
		HeadSize.f
		HeadWidth.f
		Level.l
		Maneater.w
		MagicRealms.w
		Primaryhand.w
		Race.w
		Weight.f
		SizSRM.w
		DexSRM.w
		MelSRM.w
		Movement.w
		Vampire.w
		SaveOnExit.w
		cmdNextConfig.w
		Money_Income.l[#CoinTypes]
		Money_Carried.l[#CoinTypes]
		Money_Bank.l[#CoinTypes]
		MagicalSkinArmor.w[#NumberOfCharacteristicStats]
		WeaponSkill.CharWeaponSkills[#WeaponTotal]
		GeneralSkills.GeneralSkills[#GeneralTotal]
		;Weapon_AttackSkill.w[#WEAPONSKILLSTOTAL]
		;Weapon_AttackSkillExperience.w[#WEAPONSKILLSTOTAL]
		;Weapon_ParrySkill.w[#WEAPONSKILLSTOTAL]
		;Weapon_ParrySkillExperience.w[#WEAPONSKILLSTOTAL]
		Attribute.StatAttributes[#NumberOfCharacteristicStats]
	;	NaturalArmorLocation.w[#NumberOfHumanBodyLocations]
		; 0,0 -> 1,6
	;	Attributes_Original.w[#NumberOfHumanBodyLocations]    ; attributes(0 to 1,0 to 6)
	;	Attributes_Modified.w[#NumberOfHumanBodyLocations]	  ; attributes(0 to 1,0 to 6)
	;	AttriButes_FixedStat.w[#NumberOfHumanBodyLocations]
		; 0,0 -> 2,6
	;	Attributes_Magical.w[#NumberOfHumanBodyLocations] ; (0 to 2, 0 to 6
	;	SkillUsed.w[#NumberOfSkills] ; Skill used or not used that round.
	;	SkillValue.w[#NumberOfSkills]
	;	SkillBonus.w[#NumberOfSkills]
	;	SkillTotal.w[#NumberOfSkills]
	;	SkillEXP.w[#NumberOfSkills]
		CharClass.l[#NumbersOfClasses]
	EndStructure
	
	; These Data will Not be saved pr character. Only To savegames
	Structure myPC2
	    Alert.l
	    ArmsWear.l
	    AttemptKeepDown.w
	    Bleeds.w[#NumberOfHumanBodyLocations]
	    BodyPartsHP.w[#NumberOfHumanBodyLocations]
	    BodyPartsHPLow.w[#NumberOfHumanBodyLocations]
	    BodyPartsTotalHP.w[#NumberOfHumanBodyLocations]
	    BodyPartsUndamagedHP.w[#NumberOfHumanBodyLocations]
	    BodyPartsBonusHP.w[#NumberOfHumanBodyLocations] ; Not yet in use
		Attributes_Current.w[#NumberOfHumanBodyLocations] ; (0 to 2, 0 to 6
		Attributes_Fixed.w[#NumberOfHumanBodyLocations] ; (0 to 2, 0 to 6
	    Burden.w
	    bzClothingID.l[#bzLocationsMax]
	    Disabled.w
	    Dominator.l
	    Fatigue.w
	    FatigueBonus.w
	    Footwear.l
	    FootSize_Present.f
	    ForcingDown.l
	    Freeint.w
	    FilePath.u
	    GameMaster.w
	    TempPowerPoints.l
	    Hand.l[2]
	    Heldby.l
	    HealthNow1.w
	    HealthNow2.w[#NumberOfHumanBodyLocations]
	    HealthBefore1.w
	    HealthBefore2.w[#NumberOfHumanBodyLocations]
	    HandicapPenalty.l
	    Hidden.w
	    HitPoints.w
	    HitPointsLow.w
	    HitPointsBonus.w
	    HitsPercentage.f[#NumberOfHumanBodyLocations]
	    ArmorTotal.w[#NumberOfHumanBodyLocations]
	;    Armor.w[#NumberOfHumanBodyLocations]
	    MagicalArmor.w[#NumberOfHumanBodyLocations]
	    BleedValues.w[#NumberOfHumanBodyLocations]
	   	Armor.CharArmor[#NumberOfHumanBodyLocations]
	    Holds.l
	    Notes.w
	    KeptDownBy.l
	    KnockedDown.l
	    LastTargetID.l
	    Lie.w
	    Limbo.w
	    Lifestatus.w
	    MAFist.w
	    MAKick.w
	    ; Magic points related
	    MagicPoints_Temp.w
	    MagicPoints_Items.w
	    MagicPoints_Max.w
	    MagicMatrixPoints_Temp.w
	    MagicPoints_Storage.w
	    MagicMatrixPoints_Max.w
	    MovementBonus.w
	    Prone.w
	    ;ReadySpell.l[50] ; 50 slots (0 -> 49)
	    ;ReadySpellManipulations.w[#SORCERY_ENDSKILL_INDEX] ; 6 slots ( 0 to 5)
	    Speed.u
	    ShieldStrength.w
	    SpellCount.l
	    ShoeSize.f
	    TargetOrder.l
	    TargetZone.l
	    Team.l
	    TempHeight.l
	    Weapon_Number.l[2]
	    Weapon_HandsUsed.l[2]
	    Weapon_Ready.l[2]
	    Weapon_NumbersOfHandsUsed.l[2]
	    WeaponHand.l[2] ; 2 slots
	    WPLocSize.w[#WEAPONPLACEMENTTOTAL] ; 12 slots
	    MagicSkillXPFlag.l[5]
	    BonusCritical.w
	    BonusSpecial.w
	    BonusImpale.w
	    Lighten.w
	    ModifyDamage.w
	    WeaponSlot.l[#CharacterWeaponSlots]     ; 0 to #CharacterWeaponSlots - 1
	EndStructure
	
	Structure myPC3
	    ;Protected                              .w
		PlayerName.u[#PlayerNameMaxLength]
		SureName.u[#SureNameLength]
		MiddleName.u[#MiddleNameLength]
		LastName.u[#lastNameLength]
		PlayerControlled.w
	    AboveGround.f
	    HitPointTimer.l
	    HitToBodyPart.l
	    HitBy.l
	    FatigueTimer.l
	    LostBodyPart.l[#NumberOfHumanBodyLocations]
	    InventoryCount.l
	    Inventory.Charinventory[#MaxCharInventoryItems]
		*WeaponSkillPtr
		NumberOfSorcerySpells.l
		*SorcerySpellsPtr
	EndStructure
	
	Structure Vamp
	  Kinesis.w
	  Choke.w      ; Points To Vampire
	  ChokeLevel.w ; level of choke. first safe x5 for no damage.
	EndStructure
	;--- File Progress Value structure
	Structure filesize
		Total.q
		Progress.q
	EndStructure
	;--- ColorDescription Structure
	Structure ColorDescription
		ID.l
		Past.s
		Present.s
		Future.s
	EndStructure
	;--- Hair Descriptions
	Structure Hair
		id.l
		Description.s
	EndStructure
	;--- Sorcery spells
	Structure SorceryShort
		Id.l
		flgRange.a
		flgType.a
		flgTime.a
	EndStructure
	
	Structure SorceryEx Extends SorceryShort
		Name.s
	EndStructure

	Structure SorcerySkillStruct
		Id.l
		Base.u
		MagicModifier.u
		Experience.u
		Memorized.b
		Used.b
	EndStructure
	
	Structure SorceryNameStruct
		id.l
		Name.s
	EndStructure	

; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 383
; FirstLine = 346
; EnableXP